unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, ComCtrls, StdCtrls, QuizzFile, QuizzClass,
  ImgList;

type
  TFormMain = class(TForm)
    ImageQuestion: TImage;
    LabelQuestion: TLabel;
    PageControlReponse: TPageControl;
    TabSheetText: TTabSheet;
    TabSheetImage: TTabSheet;
    RadioGroupReponse: TRadioGroup;
    PanelButton: TPanel;
    ButtonNext: TButton;
    ButtonCorrection: TButton;
    TabSheetNiveau: TTabSheet;
    RadioGroupNiveau: TRadioGroup;
    ImageListValide: TImageList;
    TabSheetResultats: TTabSheet;
    LabelResultats: TLabel;
    MainPageControl: TPageControl;
    TabSheetPresentation: TTabSheet;
    TabSheetQuizz: TTabSheet;
    ImageLogo: TImage;
    LabelBienvenue: TLabel;
    ImageValide4: TImage;
    Image4: TImage;
    ImageValide2: TImage;
    Image1: TImage;
    ImageValide3: TImage;
    Image3: TImage;
    ImageValide1: TImage;
    Image2: TImage;
    PanelQuestion: TPanel;
    procedure ButtonNextClick(Sender: TObject);
    procedure ButtonCorrectionClick(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure ImageLogoClick(Sender: TObject);
    procedure LabelQuestionClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Dclarations prives }
    FQuizzFile : TWordFile;
    FQuizzClass: TQuizzClass;

    FNiveau: Integer;

    FRadioGroupColor: TColor;

    // Gestion question image
    FImageIndex: Integer;
  public
    { Dclarations publiques }
    constructor Create(AOwner: TComponent); override;

    procedure OnAfficherResultat( Reponse: Integer );
    procedure OnAfficherResultats( NombreReponseBonne, NombreReponseMauvaise: Integer );
    procedure OnAfficherQuestion( Question: TQuestion );
    procedure OnAfficherQuestionString( Question: TQuestionString );
    procedure OnAfficherQuestionPicture( Question: TQuestionPicture );
    procedure OnAfficherNiveau;
  end;

var
  FormMain: TFormMain;

implementation

uses StrUtils, IniFiles;

{$R *.dfm}

{ TFormMain }

constructor TFormMain.Create(AOwner: TComponent);
var FichierIni: TIniFile;
begin
  inherited;

  ChDir( IncludeTrailingPathDelimiter( ExtractFilePath( Application.ExeName) ) );

  FichierIni := TIniFile.Create( IncludeTrailingPathDelimiter( ExtractFilePath( Application.ExeName) ) + 'quizz.ini' );
  FQuizzFile := TWordFile.Create( FichierIni );
  FQuizzClass := nil;

  FRadioGroupColor := RadioGroupReponse.Color;
end;

procedure TFormMain.OnAfficherNiveau;
var I : Integer;
begin
  PageControlReponse.ActivePage := TabSheetNiveau;
  LabelQuestion.Caption := 'Veuillez choisir le niveau :';

  PageControlReponse.Height := PanelQuestion.Height;
  ImageQuestion.Picture.Assign( nil );

  RadioGroupNiveau.Items.Clear;
  for I := 0 to FQuizzFile.Niveaux.Count - 1 do
    RadioGroupNiveau.Items.Add( (FQuizzFile.Niveaux[I] as TNiveau).Niveau );

  ButtonCorrection.Enabled := false;
  ButtonNext.Caption := 'Valider';
  ButtonNext.Default := true;
end;

procedure TFormMain.OnAfficherQuestion(Question: TQuestion);
begin
  ButtonCorrection.Enabled := true;
  ButtonCorrection.Default := true;
  ButtonNext.Caption := 'Suivant';
  ButtonNext.Enabled := false;

  LabelQuestion.Caption := Question.Question;
  if( Question.Indice <> '' ) then
    LabelQuestion.Caption := LabelQuestion.Caption + ' (cliquer ici pour visualiser l''indice)';

  if( Assigned(Question.Image) ) then begin
    ImageQuestion.Picture.Assign( Question.Image );
    if( Question is TQuestionString ) then
      PageControlReponse.Height := 200
    else
      PageControlReponse.Height := PanelQuestion.Height - 200;
  end else begin
    PageControlReponse.Height := PanelQuestion.Height;
    ImageQuestion.Picture.Assign( nil );
  end;

  if( Question is TQuestionString ) then
    OnAfficherQuestionString( Question as TQuestionString )
  else
    OnAfficherQuestionPicture( Question as TQuestionPicture );
end;

procedure TFormMain.OnAfficherQuestionPicture(Question: TQuestionPicture);
begin
  PageControlReponse.ActivePage := TabSheetImage;
  Image1.Top := 5;
  Image1.Left := 5;
  Image1.Width := (TabSheetImage.Width div 2) - 5;
  Image1.Height := (TabSheetImage.Height div 2) - 5;
  ImageValide1.Top := Image1.Top;
  ImageValide1.Left := Image1.Left;
  ImageValide1.Height := Image1.Height;
  ImageValide1.Width := Image1.Width;
  ImageValide1.BringToFront;

  Image2.Top := Image1.Top + Image1.Height + 10;
  Image2.Left := 5;
  Image2.Width := (TabSheetImage.Width div 2) - 5;
  Image2.Height := (TabSheetImage.Height div 2) - 5;
  ImageValide2.Top := Image2.Top;
  ImageValide2.Left := Image2.Left;
  ImageValide2.Height := Image2.Height;
  ImageValide2.Width := Image2.Width;
  ImageValide2.BringToFront;

  Image3.Top := 5;
  Image3.Left := Image1.Top + Image1.Width + 10;
  Image3.Width := (TabSheetImage.Width div 2) - 5;
  Image3.Height := (TabSheetImage.Height div 2) - 5;
  ImageValide3.Top := Image3.Top;
  ImageValide3.Left := Image3.Left;
  ImageValide3.Height := Image3.Height;
  ImageValide3.Width := Image3.Width;
  ImageValide3.BringToFront;

  Image4.Top := Image1.Top + Image1.Height + 10;
  Image4.Left := Image1.Top + Image1.Width + 10;
  Image4.Width := (TabSheetImage.Width div 2) - 5;
  Image4.Height := (TabSheetImage.Height div 2) - 5;
  ImageValide4.Top := Image4.Top;
  ImageValide4.Left := Image4.Left;
  ImageValide4.Height := Image4.Height;
  ImageValide4.Width := Image4.Width;
  ImageValide4.BringToFront;

  Image1.Picture.Assign( Question.Pictures[ 0 ] as TPicture );
  Image2.Picture.Assign( Question.Pictures[ 1 ] as TPicture );
  Image3.Picture.Assign( Question.Pictures[ 2 ] as TPicture );
  Image4.Picture.Assign( Question.Pictures[ 3 ] as TPicture );

  FImageIndex := -1;
  ImageClick(nil);
end;

procedure TFormMain.OnAfficherQuestionString(Question: TQuestionString);
var I: Integer;
begin
  PageControlReponse.ActivePage := TabSheetText;

  RadioGroupReponse.Items.Assign( Question.Reponses );

  for I := 0 to RadioGroupReponse.Items.Count - 1 do begin
    (RadioGroupReponse.Controls[ I ] as TRadioButton).Color := FRadioGroupColor;
  end;

  RadioGroupReponse.ItemIndex := -1;
end;

procedure TFormMain.OnAfficherResultat(Reponse: Integer);
var TypeRep, I: Integer;
    Control: TControl;
begin
  LabelQuestion.Caption := 'Resultat';
  ButtonCorrection.Enabled := false;
  ButtonNext.Enabled := true;

  // Afficher la correction
  if( PageControlReponse.ActivePage = TabSheetText ) then begin
    if( (Reponse - 1) = RadioGroupReponse.ItemIndex ) then
      (RadioGroupReponse.Controls[ Reponse - 1 ] as TRadioButton).Color := clLime
    else
      (RadioGroupReponse.Controls[ Reponse - 1 ] as TRadioButton).Color := clRed;
  end else begin
    ImageClick(nil);

    if( Reponse = FImageIndex ) then
      TypeRep := 0
    else
      TypeRep := 1;

    for I := 0 to TabSheetImage.ControlCount - 1 do begin
      if( TabSheetImage.Controls[I].Name = 'ImageValide' + IntToStr(Reponse) ) then begin
        Control := TabSheetImage.Controls[I];
        if( Assigned(Control) ) then
          ImageListValide.GetBitmap(TypeRep, (Control as TImage).Picture.Bitmap);
        end;
      end;
    end;
end;

procedure TFormMain.OnAfficherResultats(NombreReponseBonne,
  NombreReponseMauvaise: Integer);
var NoteSur100: Integer;
begin
  PageControlReponse.ActivePage := TabSheetResultats;

  PageControlReponse.Height := PanelQuestion.Height;
  ImageQuestion.Picture.Assign( nil );

  NoteSur100 := 100 * NombreReponseBonne div (NombreReponseBonne + NombreReponseMauvaise);

  LabelResultats.Caption := Format(
                    'Et les rsultats sont : '#10#13 +
                    'Bonnes rponses : %d'#10#13 +
                    'Mauvaises rponses : %d'#10#13#10#13 +
                    'Soit une note de : %.2f/20.00'#10#13 +
                    '**** %s ****',
                    [NombreReponseBonne, NombreReponseMauvaise,
                    20 * NombreReponseBonne / (NombreReponseBonne + NombreReponseMauvaise),
                    FQuizzFile.MessageOf(NoteSur100)
                    ]);

end;

procedure TFormMain.ButtonNextClick(Sender: TObject);
begin
  if( PageControlReponse.ActivePage = TabSheetNiveau ) then begin
    FNiveau := RadioGroupNiveau.ItemIndex;

    if( Assigned(FQuizzClass) ) then begin
      FQuizzClass.Free;
      FQuizzClass := nil;
    end;

    FQuizzClass := TQuizzClass.Create( FQuizzFile, FNiveau );
    FQuizzClass.OnAfficherResultat := OnAfficherResultat;
    FQuizzClass.OnAfficherResultats := OnAfficherResultats;
    FQuizzClass.OnAfficherQuestion := OnAfficherQuestion;

    FQuizzClass.FirstQuestion;
  end else
  if( PageControlReponse.ActivePage = TabSheetResultats )then begin
    PageControlReponse.ActivePage := TabSheetNiveau;
    FQuizzClass.Free;
    FQuizzClass := nil;
  end else begin
    FQuizzClass.NextQuestion;
  end;
end;

procedure TFormMain.ButtonCorrectionClick(Sender: TObject);
begin
  if( PageControlReponse.ActivePage = TabSheetText ) then begin
    FQuizzClass.Correction( RadioGroupReponse.ItemIndex + 1 );
  end else begin
    FQuizzClass.Correction( FImageIndex );
  end;
end;

procedure TFormMain.ImageClick(Sender: TObject);
var Tag, I: Integer;
begin
  ImageValide1.Picture.Bitmap := TBitmap.Create;
  ImageValide2.Picture.Bitmap := TBitmap.Create;
  ImageValide3.Picture.Bitmap := TBitmap.Create;
  ImageValide4.Picture.Bitmap := TBitmap.Create;

  if( Assigned(Sender) ) then begin
    Tag := (Sender as TImage).Tag;

    for I := 0 to TabSheetImage.ControlCount - 1 do begin
      if( TabSheetImage.Controls[I].Name = 'ImageValide' + IntToStr(Tag) ) then begin
        ImageListValide.GetBitmap(2, (TabSheetImage.Controls[I] as TImage).Picture.Bitmap);
      end;
    end;

    FImageIndex := Tag;
  end;
end;

procedure TFormMain.ImageLogoClick(Sender: TObject);
begin
  MainPageControl.ActivePage := TabSheetQuizz;
end;

procedure TFormMain.LabelQuestionClick(Sender: TObject);
var Indice: String;
begin
  if( ( PageControlReponse.ActivePage = TabSheetText ) or ( PageControlReponse.ActivePage = TabSheetImage ) ) then begin
    Indice := ((FQuizzFile.Niveaux[ FNiveau ] as TNiveau).Questions[ FQuizzClass.QuestionIndex ] as TQuestion ).Indice;

    if( Indice <> '' ) then begin
      MessageDlg( Indice, mtInformation, [mbOk], 0 );
    end;
  end;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  MainPageControl.ActivePage := TabSheetPresentation;
  OnAfficherNiveau;
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
  ButtonNext.Left := PanelButton.Width - 5 - ButtonNext.Width;
  ButtonCorrection.Left := ButtonNext.Left - 5 - ButtonCorrection.Width;
end;

end.
